User account creation filtered due to spam.

Bug 8663 - [3.3 regression] ICE in cp_expr_size, at cp/cp-lang.c:307
Summary: [3.3 regression] ICE in cp_expr_size, at cp/cp-lang.c:307
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: c++ (show other bugs)
Version: 3.3
: P3 normal
Target Milestone: ---
Assignee: Not yet assigned to anyone
URL:
Keywords: ice-on-valid-code
Depends on:
Blocks:
 
Reported: 2002-11-20 14:46 UTC by deller
Modified: 2003-07-25 17:33 UTC (History)
3 users (show)

See Also:
Host: hppa-unknown-linux-gnu
Target: hppa-unknown-linux-gnu
Build: hppa-unknown-linux-gnu
Known to work:
Known to fail:
Last reconfirmed:


Attachments
xxx.ii.bz2 (149.70 KB, application/octet-stream)
2003-05-21 15:16 UTC, deller
Details

Note You need to log in before you can comment on or make changes to this bug.
Description deller 2002-11-20 14:46:01 UTC
shell> g++ -c xxx.ii
/home/cvs/kde20/kdelibs/kcert/kcertpart.cc: In member function `virtual bool
   KCertPart::openFile()':
/home/cvs/kde20/kdelibs/kcert/kcertpart.cc:457: internal compiler error: in
   cp_expr_size, at cp/cp-lang.c:307

Release:
g++ (GCC) 3.3 20021119 (experimental)

Environment:
System: Linux c3000 2.4.20-rc1-pa6 #329 Mon Nov 18 20:36:39 CET 2002 parisc unknown unknown GNU/Linux
Architecture: parisc

        <machine, os, target, libraries (multiple lines)>
host: hppa-unknown-linux-gnu
build: hppa-unknown-linux-gnu
target: hppa-unknown-linux-gnu
configured with: /home/cvs/gcc/configure -v --enable-languages=c,c++ --prefix=/usr/local --infodir=/share/local/info --mandir=/share/local/man --enable-shared --with-gnu-as --with-gnu-ld --with-system-zlib --enable-long-long --enable-nls --without-included-gettext --disable-checking --enable-threads=posix --with-cpp-install-dir=bin hppa-linux : (reconfigured)  : (reconfigured)

How-To-Repeat:
g++ -c xxx.ii
Comment 1 deller 2002-11-20 14:46:01 UTC
Fix:
Already fixed in GCC 3.3.
Comment 2 Volker Reichelt 2002-11-21 09:00:16 UTC
State-Changed-From-To: open->analyzed
State-Changed-Why: Confirmed.
    
    The bug can be reproduced with the following code snippet:
    
    -----------------------snip here------------------------
    struct A
    {
        A (const A&);
        A &operator= (const A&);
    };
    
    struct B { A a; };
    
    B foo();
    
    void bar() { A a = foo().a; }
    -----------------------snip here------------------------
    
    Compiling this with mainline (as of 20021118) on i686-pc-linux-gnu
    I get an ICE:
    
    PR8663.cc: In function `void bar()':
    PR8663.cc:11: internal compiler error: in cp_expr_size, at cp/cp-lang.c:307
    Please submit a full bug report, [etc.]
    
    The 3.2-branch, 3.0.x and 2.95.x are not affected.
Comment 3 Mark Mitchell 2002-12-01 20:27:37 UTC
From: mmitchel@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: c++/8663
Date: 1 Dec 2002 20:27:37 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Changes by:	mmitchel@gcc.gnu.org	2002-12-01 12:27:37
 
 Modified files:
 	gcc/cp         : ChangeLog cp-tree.h init.c rtti.c 
 	gcc/testsuite  : ChangeLog 
 Added files:
 	gcc/testsuite/g++.dg/inherit: typedef1.C typeinfo1.C 
 
 Log message:
 	PR c++/8727
 	* g++.dg/inherit/typeinfo1.C: New test.
 	
 	PR c++/8663
 	* g++.dg/inherit/typedef1.C: New test.
 	
 	PR c++/8727
 	* cp-tree.h (lang_type_class): Add typeinfo_var.
 	(CLASSTYPE_TYPEINFO_VAR): New macro.
 	* rtti.c (get_tinfo_decl): Use it.
 	
 	PR c++/8663
 	* init.c (expand_member_init): Always get the main variant of a
 	base class.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&r1=1.3061&r2=1.3062
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&r1=1.771&r2=1.772
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/init.c.diff?cvsroot=gcc&r1=1.298&r2=1.299
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/rtti.c.diff?cvsroot=gcc&r1=1.145&r2=1.146
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&r1=1.2243&r2=1.2244
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typedef1.C.diff?cvsroot=gcc&r1=NONE&r2=1.1
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typeinfo1.C.diff?cvsroot=gcc&r1=NONE&r2=1.1
 

Comment 4 Mark Mitchell 2002-12-01 20:27:37 UTC
From: mmitchel@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: c++/8663
Date: 1 Dec 2002 20:27:37 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Changes by:	mmitchel@gcc.gnu.org	2002-12-01 12:27:37
 
 Modified files:
 	gcc/cp         : ChangeLog cp-tree.h init.c rtti.c 
 	gcc/testsuite  : ChangeLog 
 Added files:
 	gcc/testsuite/g++.dg/inherit: typedef1.C typeinfo1.C 
 
 Log message:
 	PR c++/8727
 	* g++.dg/inherit/typeinfo1.C: New test.
 	
 	PR c++/8663
 	* g++.dg/inherit/typedef1.C: New test.
 	
 	PR c++/8727
 	* cp-tree.h (lang_type_class): Add typeinfo_var.
 	(CLASSTYPE_TYPEINFO_VAR): New macro.
 	* rtti.c (get_tinfo_decl): Use it.
 	
 	PR c++/8663
 	* init.c (expand_member_init): Always get the main variant of a
 	base class.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&r1=1.3061&r2=1.3062
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&r1=1.771&r2=1.772
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/init.c.diff?cvsroot=gcc&r1=1.298&r2=1.299
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/rtti.c.diff?cvsroot=gcc&r1=1.145&r2=1.146
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&r1=1.2243&r2=1.2244
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typedef1.C.diff?cvsroot=gcc&r1=NONE&r2=1.1
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typeinfo1.C.diff?cvsroot=gcc&r1=NONE&r2=1.1
 

Comment 5 Mark Mitchell 2002-12-01 20:40:38 UTC
From: mmitchel@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: c++/8663
Date: 1 Dec 2002 20:40:38 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Branch: 	gcc-3_2-branch
 Changes by:	mmitchel@gcc.gnu.org	2002-12-01 12:40:38
 
 Modified files:
 	gcc/cp         : ChangeLog cp-tree.h init.c rtti.c 
 	gcc/testsuite  : ChangeLog 
 Added files:
 	gcc/testsuite/g++.dg/inherit: typedef1.C typeinfo1.C 
 
 Log message:
 	PR c++/8727
 	* g++.dg/inherit/typeinfo1.C: New test.
 	
 	PR c++/8663
 	* g++.dg/inherit/typedef1.C: New test.
 	
 	PR c++/8727
 	* cp-tree.h (lang_type_class): Add typeinfo_var.
 	(CLASSTYPE_TYPEINFO_VAR): New macro.
 	* rtti.c (get_tinfo_decl): Use it.
 	
 	PR c++/8663
 	* init.c (expand_member_init): Always get the main variant of a
 	base class.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.2685.2.114.2.46&r2=1.2685.2.114.2.47
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.681.2.12.2.9&r2=1.681.2.12.2.10
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/init.c.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.264.2.12.2.2&r2=1.264.2.12.2.3
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/rtti.c.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.130.6.2&r2=1.130.6.3
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.1672.2.166.2.61&r2=1.1672.2.166.2.62
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typedef1.C.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=NONE&r2=1.1.2.1
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typeinfo1.C.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=NONE&r2=1.1.2.1
 

Comment 6 Mark Mitchell 2002-12-01 20:40:38 UTC
From: mmitchel@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: c++/8663
Date: 1 Dec 2002 20:40:38 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Branch: 	gcc-3_2-branch
 Changes by:	mmitchel@gcc.gnu.org	2002-12-01 12:40:38
 
 Modified files:
 	gcc/cp         : ChangeLog cp-tree.h init.c rtti.c 
 	gcc/testsuite  : ChangeLog 
 Added files:
 	gcc/testsuite/g++.dg/inherit: typedef1.C typeinfo1.C 
 
 Log message:
 	PR c++/8727
 	* g++.dg/inherit/typeinfo1.C: New test.
 	
 	PR c++/8663
 	* g++.dg/inherit/typedef1.C: New test.
 	
 	PR c++/8727
 	* cp-tree.h (lang_type_class): Add typeinfo_var.
 	(CLASSTYPE_TYPEINFO_VAR): New macro.
 	* rtti.c (get_tinfo_decl): Use it.
 	
 	PR c++/8663
 	* init.c (expand_member_init): Always get the main variant of a
 	base class.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.2685.2.114.2.46&r2=1.2685.2.114.2.47
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.681.2.12.2.9&r2=1.681.2.12.2.10
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/init.c.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.264.2.12.2.2&r2=1.264.2.12.2.3
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/rtti.c.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.130.6.2&r2=1.130.6.3
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=1.1672.2.166.2.61&r2=1.1672.2.166.2.62
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typedef1.C.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=NONE&r2=1.1.2.1
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/typeinfo1.C.diff?cvsroot=gcc&only_with_tag=gcc-3_2-branch&r1=NONE&r2=1.1.2.1
 
Comment 7 Mark Mitchell 2002-12-09 23:23:09 UTC
State-Changed-From-To: analyzed->closed
State-Changed-Why: Already fixed in GCC 3.3.